﻿

// define lazybind
(function($){
    $.fn.lazybind = function(event, fn, timeout, abort){
        var timer = null;
        $(this).bind(event, function(e){
            var ev = e;
            timer = setTimeout(function(){
                fn(ev);
            }, timeout);
        });
        if(abort == undefined){
            return;
        }
        $(this).bind(abort, function(){
            if(timer != null){
                clearTimeout(timer);
            }
        });
    };
})(jQuery);


$(window).lazybind('hashchange', function() {
	if (getHasScrollTo()) {	
		scrollId=scrollDown();
		console.log('[' + new Date().toUTCString() + '] '+ " Click: scroll=" + scrollId)
		scrolltarget=document.getElementById(scrollId)
		otop=scrolltarget.offsetTop
		//console.log('[' + new Date().toUTCString() + '] '+ " Click: scroll=" + scrollId+" offsettop="+otop+" window.scrollY="+window.scrollY +" document.body.clientHeight="+document.body.clientHeight)
		window.scrollTo(0,otop)
		scrolltarget.nextSibling.classList.add("item-highlight")
		//console.log('[' + new Date().toUTCString() + '] '+ "-> Click scrolled: window.scrollY="+window.scrollY)	
	}
		
},1200);	

function sleep(miliseconds)
{
	var currentTime = new Date().getTime();
	while (currentTime + miliseconds >= new Date().getTime()) {}
}

function getToggleID() {
	var hasScrollTo = getHasScrollTo();
	var possibleIds = getPossibleIds();
	var toggleid = possibleIds[possibleIds.length - 1];
	var scrollId = possibleIds[possibleIds.length - 1];
	if(hasScrollTo)
	{
		toggleid = possibleIds[possibleIds.length - 2];
	}
	return toggleid
}

function getScrollID() {
	var possibleIds = getPossibleIds();
	var scrollId = possibleIds[possibleIds.length - 1];
	if(getHasScrollTo()) {
		return scrollId
	}
	else {
		return false
	}
}


function scrollDown()
{
	var hasScrollTo = getHasScrollTo();
	var possibleIds = getPossibleIds();
	var toggleid = possibleIds[possibleIds.length - 1];
	var scrollId = possibleIds[possibleIds.length - 1];
	if(hasScrollTo)
	{
		toggleid = possibleIds[possibleIds.length - 2];
	}

	// THB Aug 7, 2019
	console.log('[' + new Date().toUTCString() + '] '+ " scrollDown: " + toggleid + ", scroll=" + scrollId)
	
	if(toggleid)
	{
		var div = document.getElementById(toggleid);
		//var fireEvent = div.childNodes[0].childNodes[0].className.includes("is-open");
		var fireEvent = (div.childNodes[0].childNodes[0].className.indexOf("is-open")) !== -1;
		
		// toggle the toggleid in the hash
		if(fireEvent === false){
			eventFire(eventFire(document.getElementById(toggleid), 'click'))
		}
		
		

		// THB Aug 6, 2019: remove scrollid from hash
		window.location.hash=window.location.hash.replace(/\/scrollto=/,"/")

		sleep(500);
		scrollId = scrollId + "_scrolltarget";
		if(fireEvent === true){
			if(document.getElementById(scrollId))
			{
				otop=document.getElementById(scrollId).offsetTop
				console.log('[' + new Date().toUTCString() + '] '+ "- scrollIntoView: scroll=" + scrollId+" offsettop="+otop+" window.scrollY="+window.scrollY)
				document.getElementById(scrollId).scrollIntoView();
				console.log('[' + new Date().toUTCString() + '] '+ "- scrolled: window.scrollY="+window.scrollY)

			}
		}
	}
	
	return scrollId;
}
	
function getHasScrollTo()
{
	var hash = window.location.hash.slice(1);
	//return hash.includes("scrollto");
	return (hash.indexOf("scrollto") !== -1)
}

function getPossibleIds()
{
	var hash = window.location.hash.slice(1);
	var possibleIds = hash.replace(/^\//, "").replace(/\/$/, "").replace(/Togglebox=/g, "").replace(/scrollto=/g, "").split("/")
	return possibleIds;
}


function eventFire(el, etype){
	if(el !== null)
	{
		if (el.fireEvent) {
			el.fireEvent('on' + etype);
		} else {
			var evObj = document.createEvent('Events');
			evObj.initEvent(etype, true, false);
			el.dispatchEvent(evObj);
		}
	}
}